Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/README
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/README	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/README	(revision 34921)
@@ -438,50 +544,63 @@
                   which are done later only if the value is requested).  May be
                   a scalar expression using $val (the Raw tag value), $self (the
-                  current ExifTool object), $tag (the tag key) and $tagInfo
-                  (reference to the tag information hash) or a code reference
-                  with $val and $self as arguments.  For Composite tags, $val is
-                  a reference to a hash of source ("derived from") tag names,
-                  and @val may be used to access the Raw values of these tags.
-                  If RawConv is specified for a Composite tag, then ValueConv
-                  and PrintConv evals will no longer have access to the source
-                  @val and @prt values.  The returned value may be a scalar
-                  which is used as the new Raw value, a scalar reference to a
-                  binary data value, a hash reference for Composite tags, an
-                  ARRAY reference for a list of values, or undefined to indicate
-                  that the tag should be ignored.  Also, RawConv may generate
-                  Warning or Error tags, while ValueConv and PrintConv may not. 
+                  current ExifTool object), $tag (the tag key), $tagInfo
+                  (reference to the tag information hash), $priority (to
+                  dynamically set the priority of a tag), and @grps (to
+                  dynamically set the family and/or groups), or a code reference
+                  with $val and $self as arguments (in which case $$self{grps}
+                  may be used to set the groups).  For Composite tags, $val is a
+                  reference to a hash of source ("derived from") tag names, and
+                  @val may be used to access the Raw values of these tags.  The
+                  returned value may be a scalar which is used as the new Raw
+                  value, a scalar reference to a binary data value, a hash
+                  reference for Composite tags, an ARRAY reference for a list of
+                  values, or undefined to indicate that the tag should be
+                  ignored.  If RawConv is specified for a Composite tag, then
+                  ValueConv and PrintConv evals will no longer have access to
+                  the source @val and @prt values unless the input $val is
+                  returned.  RawConv may generate Warning or Error tags, while
+                  ValueConv and PrintConv should not (see ValueConv note below).
                   Note: RawConv should only be used if necessary (in general,
-                  only if the conversion may return undef to ignore the tag)
-                  because ValueConv is more efficient since it is only executed
-                  if the tag value is requested, while RawConv is executed for
-                  all extracted tags.
+                  only if the conversion may return undef to ignore the tag, or
+                  if a Warning may be issued) because ValueConv is more
+                  efficient since it is only executed if the tag value is
+                  requested, while RawConv is executed for all extracted tags.
+                  Note that a tag is still writable if it has a RawConv without
+                  a RawConvInv (with the exception of QuickTime ItemList and
+                  UserData tags, which specifically require this), but this is
+                  not true for ValueConv/PrintConv.
 
   ValueConv     : Used to convert the Raw value to a useable form. May be a hash
                   reference to act as a lookup table, a scalar which is
-                  evaluated as a Perl expression, or a code reference to a
-                  subroutine.  May also be a list reference, in which case the
-                  value is split at whitespace into a list of values and each
-                  value is converted by the associated entry in the ValueConv
-                  list.  If a hash reference is used and the Raw value doesn't
-                  appear as one of the keys, then the converted value is set to
-                  "Unknown (X)", where X is the Raw value (unless either of the
-                  special keys exist: 'BITMASK', a reference to a hash used to
-                  decode individual value bits; or 'OTHER', a reference to a
-                  subroutine used to convert unknown values.  The subroutine
-                  takes 3 arguments: the value, a flag which is set for the
-                  inverse conversion, and a reference to the PrintConv hash, and
-                  returns the converted value or undef on error.  The lookup
-                  hash may also contain a 'Notes' entry which is used for
-                  documentation if the SeparateTable flag is set).  In an
-                  expression, $self is a reference to the current ExifTool
-                  object, $val is the Raw value, and $tag is the tag key.  The
-                  subroutine takes 2 arguments: the Raw value and a reference to
-                  the current ExifTool object.  The expression or subroutine is
-                  evaluated when and if the tag value is requested (ie. only
-                  after all extraction is complete), so if necessary at this
-                  time the values of all other tags are available via calls to
-                  $self->GetValue("Tag","Raw"). (Note: In theory, types other
+                  evaluated as a Perl expression, a code reference to a
+                  subroutine, or an ARRAY reference (in which case the value is
+                  split at whitespace into a list of items and each item is
+                  converted by the associated entry in the ValueConv list.  A
+                  special value of 'REPEAT' may be used to repeat the previous
+                  conversion for all remaining elements).  If a hash reference
+                  is used and the Raw value doesn't appear as one of the keys,
+                  then the converted value is set to "Unknown (X)", where X is
+                  the Raw value (unless either of the special keys exist:
+                  'BITMASK', a reference to a hash used to decode individual
+                  value bits; or 'OTHER', a reference to a subroutine used to
+                  convert unknown values.  The OTHER subroutine takes 3
+                  arguments: the value, a flag which is set for the inverse
+                  conversion, and a reference to the PrintConv hash, and returns
+                  the converted value or undef on error -- it may call warn() to
+                  return an error message. The lookup hash may also contain a
+                  'Notes' entry which is used for documentation if the
+                  SeparateTable flag is set). In an expression, $self is a
+                  reference to the current ExifTool object, $val is the Raw
+                  value, and $tag is the tag key.  The subroutine takes 2
+                  arguments: the Raw value and a reference to the current
+                  ExifTool object.  The advanced formatting expression (if any)
+                  may be accessed via the ExifTool "FMT_EXPR" member variable. 
+                  The expression or subroutine is evaluated if and when the tag
+                  value is requested (ie. only after all extraction is
+                  complete), so if necessary at this time the values of all
+                  other tags are available via calls to
+                  $self->GetValue("Tag","Raw").  (Note: In theory, types other
                   than "Raw" may be accessed, but they are slower and may lead
-                  to cyclical dependencies so they should be avoided). When
+                  to cyclical dependencies so they should be avoided).  When
                   evaluated, the expression or subroutine returns a scalar for
                   the converted value, a SCALAR reference to a binary data value
@@ -491,7 +610,8 @@
                   value for validity, otherwise an undef tag may hide a
                   previously defined value when the Duplicates option is not
-                  enabled.  If this isn't possible (as with Composite tags where
+                  enabled. If this isn't possible (as with Composite tags where
                   the converted values of the source tags are needed), set the
-                  Priority to 0 to avoid taking priority over a valid tag. 
+                  Priority to 0 to avoid taking priority over a valid tag. If
+                  ValueConv is not specified, the Raw value is not converted. 
                   Composite tags which Require or Desire other tags may access
                   the ValueConv, PrintConv and Raw values of these tags through
@@ -500,6 +620,9 @@
                   reference).  For these tags, $val may be used in an expression
                   to represent $val[0], and the first argument passed for a code
-                  reference is a reference to @val. If ValueConv is not
-                  specified, the Raw value is not converted.
+                  reference is a reference to @val. Note:  Warnings issued by
+                  these conversions are intercepted by ExifTool and saved as
+                  Warning tags, but since ValueConv and PrintConv conversions
+                  are done on demand, the warnings may be generated after the
+                  list of extracted tags is returned, so may easily be missed.
 
   PrintConv     : This entry is similar to ValueConv above, except that it is
@@ -542,14 +665,24 @@
                   undef).
 
-  PrintConvInv  : The inverse of PrintConv.  Only necessary if for Writable tags
-                  when PrintConv is specified (unless WriteAlso is used).  See
-                  ValueConvInv above for more details.
-
-  PrintConvColumns : Number of columns for PrintConv lookup in HTML docs.
-                  Default is 1 if not specified.
+  PrintConvInv  : The inverse of PrintConv.  Necessary for Writable tags
+                  when PrintConv is specified (unless WriteAlso is used), but
+                  may be used without PrintConv.  See ValueConvInv above for
+                  more details.
+
+  PrintConvColumns : Number of columns for PrintConv lookup in HTML docs. If not
+                  set, the number of columns is determined automatically
+                  according to the maximum width of the entries.
 
   DelValue      : Raw value to be used when deleting a permanent tag.  (Note all
                   MakerNotes tags are permanent.)  If not specified, an attempt
                   is made to convert an empty string for the raw value.
+
+  Validate      : Scalar expression used to validate the raw value of a tag when
+                  the Validate option is set.  The expression may access $val
+                  (the Raw tag value), $tag (the tag key) and $self (the current
+                  ExifTool object), and should return a warning if any problem
+                  is found, or false if OK.  The evaluation is performed in the
+                  Image::ExifTool::Validate package namespace, so functions of
+                  this package need not be prefixed by the package name.
 
   Relist        : [Only if ValueConv or PrintConv is a list ref] Reference to a
@@ -563,6 +696,11 @@
                   may have the same index by using floating point indices.  An
                   unknown tag will only be generated for a certain TagID if
-                  there is no integral TagID for that tag.)  When Mask is used,
-                  PrintHex=1 is implied unless otherwise defined.
+                  there is no integral TagID for that tag.)  The Mask and
+                  BitShift are applied before evaluating RawConv.
+
+  BitShift      : [Mask tags only] Bit shift for Mask-ed values.  If not
+                  specified, set to the number of trailing bits in the Mask.
+                  When reading, the value is shifted right by this number of
+                  bits after the Mask is applied.
 
   Condition     : If given, specifies scalar which is evaluated as a Perl
@@ -573,29 +711,35 @@
                   expression may use $self to access the ExifTool object.  The
                   first 128 bytes of the raw data value are accessible through
-                  the reference $valPt for EXIF, Jpeg2000 and BinaryData tags
-                  only (note that for BinaryData tags, the raw data of $$valPt
-                  is always 'undef' type, and may not be used when writing
-                  except for SubDirectory tags).  EXIF tags may also reference
-                  the format string and value count through $format and $count.
-                  Note that if the value is writable and $valPt is used, the tag
-                  must have a Format (unless 'undef' or 'string'), and a Count
-                  (unless 1 or length of the 'undef' or 'string'), so the raw
-                  data may be generated for evaluating the Condition.  When
-                  writing, $valPt, $format and $count refer to the new value,
-                  except for MakerNotes tags where $format and $count refer to
-                  the old tag if it existed.
+                  the reference $valPt for EXIF, Jpeg2000, QuickTime and
+                  BinaryData tags only (note that for BinaryData tags, the raw
+                  data of $$valPt is always 'undef' type, and may not be used
+                  when writing except for SubDirectory tags).  EXIF tags (and
+                  maybe some other types) may also reference the format string
+                  and value count through $format and $count.  Note that if the
+                  value is writable and $valPt is used, the tag must have a
+                  Format (unless 'undef' or 'string'), and a Count (unless 1 or
+                  length of the 'undef' or 'string'), so the raw data may be
+                  generated for evaluating the Condition.  When writing, $valPt,
+                  $format and $count refer to the new value, except for
+                  MakerNotes tags where $format and $count refer to the old tag
+                  if it existed.
 
   Require       : [Composite tags only] A hash reference specifying the tags
-                  required to calculate the composite tag value.  The hash
+                  required to calculate the Composite tag value.  The hash
                   values are the names of the required tags, and the keys
                   specify the indices where the tag values are stored in the
                   @val list used in the ValueConv and/or PrintConv expression.
-                  The composite value is only calculated if the values for all
-                  Require'd tags are defined.  Require and Desire tag names may
-                  be prefixed by an optional group family 0 or 1 name followed
-                  by a colon.  Case IS significant.  A special feature allows
-                  a scalar tag name to be used instead of the hash reference
-                  when only the 0th tag is defined.  For example, the following
-                  two definitions are equivalent:
+                  The Composite value is only calculated if the values for all
+                  Require'd tags are defined.  Require, Desire and Inhibit tag
+                  names may be prefixed by an optional group family 0 or 1 name
+                  followed by a colon.  Case IS significant.  The keys used by
+                  the Require, Desire and Inhibit hashes must not overlap (since
+                  they are used as indices into the common @val, @prt and @raw
+                  lists), and together the keys must be sequential starting from
+                  0.  A special feature allows a scalar tag name to be used
+                  instead of the hash reference, in which case the next
+                  available index will be used (avoiding collisions with Desire
+                  and Inhibit hash entries).  For example, the following two
+                  definitions are equivalent:
 
                         Require => { 0 => 'XMP:Title' },
@@ -603,32 +747,45 @@
 
   Desire        : [Composite tags only] This is the same as Require except that
-                  the value is still calculated even if the specified tags don't
-                  exist.  Beware that the elements of @val, @prt and @raw may be
-                  undefined for Desire'd tags.  Both Require and Desire may
-                  exist together, however be sure to specify unique keys for
-                  each tag since they are used as indices into the @val, @prt
-                  and @raw lists common to both Require'd and Desire'd tags.
+                  the Composite value is calculated even if the specified tags
+                  don't exist.  Beware that the elements of @val, @prt and @raw
+                  may be undefined for Desire'd tags.  If no tags are Require'd,
+                  at least one of the Desire'd tags must exist for the Composite
+                  tag to be generated.  If there are no Require'd or Desire'd
+                  tags, then the Composite tag is always generated.  A scalar
+                  Desire tag name is given the next available index (after
+                  scalar Require tags are allocated).
+
+  Inhibit       : [Composite tags only] Similar to the Require and Desire
+                  hashes, except that the Composite tag is NOT built if any of
+                  the Inhibit tags exist.  A scalar tag name is given the next
+                  available index (after scalar Require and Desire tags are
+                  allocated).
 
   Shift         : [Writable tags only] Specifies type of shift to apply if this
                   value may be shifted.  Set to 'Time' for shifting date/time
-                  tags.
-
-  Writable      : Indicates this tag can be written (or not written if value is
-                  set to zero), and for EXIF-type tables gives format for
-                  writing.  Writable may be set to 1 for MakerNotes information
-                  because the existing format is always used, however providing
-                  a format is desireable because it is used in validating the
-                  value.  For EXIF tables, the Writable flag may be different
-                  than the Format flag, in which case Format is used for
-                  converting the binary value and Writable specifies the format
-                  code written to the EXIF IFD.  For SubDirectories in EXIF
-                  information, this flag is only defined if the SubDirectory is
-                  writable as a block, or if the SubDirectory can not be edited
-                  (in which case Writable is set to 0).  If non-zero, the
-                  SubDirectory is also extracted as a block, so the Binary and
-                  Protected flags should usually set as well.  There is
-                  currently no way to specify a write format for a SubDirectory
-                  that is not writable as a block (the default is 'int32u' for
-                  IFD-type SubDirectories, and 'undef' for all others).
+                  tags, or '0' to prevent tag from being shifted or
+                  conditionally deleted.
+
+  Writable      : Indicates this tag can be written (or not written if Writable
+                  is set to zero), and for EXIF and QuickTime tables gives
+                  format for writing.  Writable may be set to 1 for MakerNotes
+                  information because the existing format is always used,
+                  however providing a format is desirable because it is used in
+                  validating the value.  Set to 2 for tag to show "yes" in the
+                  Writable column of the tag name documentation even when there
+                  is no WRITE_PROC defined (eg. if it is written via an Extra
+                  tag).  For EXIF and QuickTime tables, the Writable flag may be
+                  different than the Format flag, in which case Format is used
+                  for converting the binary value and Writable specifies the
+                  format code written to the EXIF IFD.  For SubDirectories in
+                  EXIF information, this flag is only defined if the
+                  SubDirectory is writable as a block, or if the SubDirectory
+                  can not be edited (in which case Writable is set to 0).  If
+                  non-zero, the SubDirectory is also extracted as a block, so
+                  the Binary and Protected flags should usually set as well. 
+                  There is currently no way to specify a write format for a
+                  SubDirectory that is not writable as a block (the default is
+                  'int32u' for IFD-type SubDirectories, and 'undef' for all
+                  others).
 
   WriteAlso     : Used for writable tag to specify other tags to write when this
@@ -636,19 +793,21 @@
                   are the names of the tags to write, and the values are
                   evaluated to obtain the ValueConv values of each tag (or undef
-                  to delete the tag).  In the eval, $val is the Raw value of the
-                  parent tag (which may be undef if the tag is being deleted),
-                  and the %opts hash may be accessed to modify SetNewValue
-                  options for each tag.  By default, Type is set to "ValueConv"
-                  and the Protected option has bit 0x02 set to allow writing of
-                  Protected tags that aren't directly writable.  The AddValue
-                  and DelValue options from the parent tag are also defined, but
-                  no other options are set by default.  Previous new values of
-                  WriteAlso tags have already been removed prior to the eval if
-                  the Replace option was used for the parent tag.  If an empty
-                  warning is issued ("\n"), the target tag is not written and no
-                  error is reported.
+                  to delete the tag).  In the eval, $val is the new Raw value of
+                  the parent tag (which may be undef if the tag is being
+                  deleted, and should not be modified because it will affect
+                  subsequent WriteAlso tags), and the %opts hash may be accessed
+                  to modify SetNewValue options for each tag.  By default, Type
+                  is set to "ValueConv" and the Protected option has bit 0x02
+                  set to allow writing of Protected tags that aren't directly
+                  writable.  The AddValue, DelValue, Shift and Replace options
+                  from the parent tag are also defined, but no other options are
+                  set by default. Previous new values of WriteAlso tags have
+                  already been removed prior to the eval if the Replace option
+                  was used for the parent tag.  If an empty warning is issued
+                  ("\n"), the target tag is not written and no error is
+                  reported.
 
   WriteCheck    : If given, specifies a scalar which is evaluated as a Perl
-                  expression for a one-time validatation the value being
+                  expression for a one-time validatation the Raw value being
                   written.  The expression has access to 3 variables: $val is
                   the value to be written, $self is the ExifTool object, and
@@ -658,9 +817,14 @@
                   issued, but WriteAlso is still evaluated if it exists.
 
+  WriteHook     : [QuickTime only] Routine to call with these arguments when tag
+                  is encountered during writing: 0) tag value, 1) ExifTool ref.
+
+  WriteOnly     : Flag set if tag is write-only.  Used for documentation only.
+
   DelCheck      : Similar to WriteCheck, but called when the tag is deleted. The
                   expression may access $self, $tagInfo and $wantGroup.  Returns
                   error string, or undef on success, and may set $val to
                   something other than undef.  May return empty string ('') to
-                  suppress warning messages but not delete tag (ie. when
+                  suppress warning messages but not delete tag (eg. when
                   deleting only associated tags).
 
@@ -670,10 +834,17 @@
                   and returns true if it is OK for writing.  Unlike WriteCheck
                   which is done only once when the new value is set, this
-                  condition is evaluated just before the tags of the specific
-                  SubDirectory are written.
-
-  WriteGroup    : [Writable EXIF tags only] Specifies the IFD where the
-                  information gets written by default.  Must be defined for
-                  writable EXIF tags if WRITE_GROUP is not specified in table.
+                  condition is evaluated just before the tag is written to the
+                  file.
+
+  WriteGroup    : [Writable EXIF and Composite tags only] Specifies the IFD
+                  where the information gets written by default.  Must be
+                  defined for writable EXIF tags if WRITE_GROUP is not specified
+                  in table.  A WriteGroup of 'All' is special:  For writable
+                  Composite tags this causes any group specified for the
+                  Composite tag to be propagated to the WriteAlso tags when
+                  writing.  For other tags this allows writing to all EXIF IFD's
+                  simultaneously (in which case the tag should have a Condition
+                  or WriteCondition to restrict the IFD's to which the tag is
+                  actually written).
 
   IsOverwriting : [Writable EXIF tags only] Specifies reference to subroutine
@@ -681,4 +852,11 @@
                   0) ExifTool object ref, 1) new value hash ref, 2) old value,
                   3) new value reference.
+
+  Preferred     : This tag is always preferred when writing.
+
+  Override      : [User-defined Composite tags only] Flag to specify that the
+                  new tag definition should override the definition of existing
+                  Composite tags with the same name.  Default is 1 unless
+                  otherwise specified.
 
   AllowGroup    : [Writable tags only] Regular expression string (case
@@ -701,4 +879,13 @@
                   image offset, and is only used if the preview is outside the
                   APP1 EXIF segment.
+
+  BitsPerWord   : [BITMASK tags only] Number of bits per decoded word.  Defaults
+                  to 32 if not specified.
+
+  BitsTotal     : [Writable BITMASK tags only] Total number of bits in bit mask.
+                  Defaults to BitsPerWord if not specified.
+
+  FixedSize     : [EXIF only] Hack to ignore value size and use this instead.
+                  Only valid if Format is also defined.
 
   Struct        : [XMP tags only] Reference to structure hash for structured XMP
@@ -710,9 +897,18 @@
                   have ValueConv/PrintConv entries, because values that are HASH
                   references are are also used by Composite tags, which use the
-                  the Conv entries to generate the composite value.
+                  the Conv entries to generate the Composite value.
+
+  NoSubStruct   : [XMP tags only] Flag set in flattened tag to break cyclical
+                  recursion in nested structures.
 
   Namespace     : [XMP tags only] Gives standard XMP namespace prefix to use for
                   this tag.  If not defined, the tag table NAMESPACE is used.
 
+  FlatName      : [Struct tags and structure fields only] Name used for
+                  automatically-generated flattened tag names, defaults to Name
+                  if not specified.  In general, this is used to remove the
+                  redundant names found in some specifications.  May be empty
+                  ('') for a Struct tag but not for a structure field.
+
   Units         : [MIE tags only] Reference to a list of valid units strings.
                   The default units are the first item in the list.
@@ -720,7 +916,21 @@
   Hook          : [BinaryData tags only] Expression to be evaluated when
                   extracting tag to allow dynamic Format, etc for BinaryData
-                  tags.  May access $self, and assign a new value to $format to
-                  dynamically set the tag format, and/or increment $varSize to
-                  add a byte offset to subsequent tags.
+                  tags.  May access $self, $size (the full size of the binary
+                  data record), $dataPt (reference to the data block), and $pos
+                  (position of this tag in the data block), and assign a new
+                  value to $format to dynamically set the tag format, and/or
+                  increment $varSize to add a byte offset to subsequent tags. 
+                  $varSize may be set to a large number to effectively abort
+                  processing of the directory after this tag.  Must have
+                  corresponding DATAMEMBER entry in writable tables.  Must not
+                  have Unknown set.
+
+  LargeTag      : [BinaryData tags only] Flag to indicate that the data for this
+                  tag is large, and that it shouldn't be stored in the %val
+                  hash, even if the tag exists as a DATAMEMBER.
+
+  SetBase       : [QuickTime and BinaryData tags only] Sets ExifTool BASE offset
+                  for use when ExtractInfo is called with the ReEntry flag from
+                  inside the RawConv of a tag.
 
   TagID         : [reserved] Used internally to save the table key for this tag.
@@ -742,6 +952,9 @@
                   for these the full property path is not stored.
 
-  SrcTagInfo    : [reserved] Used internally by XMP module to store reference to
-                  default language tagInfo hash for alternate-language tags.
+  SrcTagInfo    : [reserved] Used internally to store reference to default
+                  language tagInfo hash for alternate-language tags.
+
+  OtherLang     : [reserved] Used internally by QuickTime module to store a list
+                  of tag ID's for alternate-language tags based on this one.
 
   RootTagInfo   : [reserved] Used internally to store a reference to the tag
@@ -753,11 +966,13 @@
 
   LangCode      : [reserved] Used internally to indicate language code for
-                  alternate language tags (ie. 'fr').  Only used with formats
-                  which support alternate languages (ie. XMP, MIE, etc).
+                  alternate language tags (eg. 'fr').  Only used with formats
+                  which support alternate languages (eg. XMP, MIE, etc).
 
   SubDirectory {  If it exists, this specifies the start of a new subdirectory.
                   It contains a collection of variables which specify the type
-                  and location of the subdirectory.  These variables are
-                  described below:
+                  and location of the subdirectory.  Note that ValueConv and
+                  PrintConv do not apply to SubDirectory tags, but RawConv is
+                  evaluated before the SubDirectory is processed.  The following
+                  is a list of SubDirectory variables:
 
      TagTable   : Specifies the name of the tag table lookup for the new
